
#include "FileSelector.h"
#include "ShapeFile.h"
#include "GLFFile.h"
#include "ProgressUpdater.h"




bool CFileSelector::Load(const char* strFile, C2DHoledPolyBaseSet& polys, CProgressUpdater* pUpdater)
{
	if (strstr(strFile, ".glf"))
	{
		return CGLFFile::Load(strFile, (C2DBaseSet&) polys, pUpdater);
	}
	else if (strstr(strFile, ".shp"))
	{
		return CShapeFile::Load(strFile, polys, pUpdater);
	}
	return false;
}


bool CFileSelector::Save(const char* strFile, C2DHoledPolyBaseSet& polys, CProgressUpdater* pUpdater)
{
	if (strstr(strFile, ".glf"))
	{
		return CGLFFile::Save(strFile, (C2DBaseSet&) polys, false, pUpdater);
	}
	else if (strstr(strFile, ".shp"))
	{
		return CShapeFile::Save(strFile, polys, pUpdater);
	}
	return false;
}