/*---------------------------------------------------------------------------
Copyright (C) GeoLib.
This code is used under license from GeoLib (www.geolib.co.uk). This or
any modified versions of this cannot be resold to any other party.
---------------------------------------------------------------------------*/


/**--------------------------------------------------------------------------<BR>
\file CFileSelector.h
\brief Declaration file for the CFileSelector class. 

\class CFileSelector
\brief Class to load shape files or geolib files depending on the extension. 
<P>---------------------------------------------------------------------------*/

#pragma once

class CProgressUpdater;
class C2DHoledPolyBaseSet;


#ifdef _VIEW_EXPORTING
	#define VIEW_DECLSPEC		__declspec(dllexport)
#else 
	#ifdef _STATIC
		#define VIEW_DECLSPEC
	#else
		#define VIEW_DECLSPEC		__declspec(dllimport)
	#endif
#endif

class VIEW_DECLSPEC CFileSelector
{
public:

	static bool Load(const char* strFile, C2DHoledPolyBaseSet& polys, CProgressUpdater* pUpdater = 0);

	static bool Save(const char* strFile, C2DHoledPolyBaseSet& polys, CProgressUpdater* pUpdater = 0);

};
