

#include "stdafx.h"
#include "Utilities.h"
#include <memory>





namespace Utilities
{

//using namespace Utilities;

void ReverseByteOrder(void* pValue, int nByteLength)
{
	unsigned char* pBuffer = new unsigned char[nByteLength];
	unsigned char* pCopy = new unsigned char[nByteLength];
	// Copy the value of the arg into the buffer.
	memcpy(pBuffer, pValue, nByteLength);

	//// increment pCopy to its last byte
	pCopy += nByteLength;
	//// copy each byte from the buffer into the copy in reverse order
	for (int i = 0 ; i < nByteLength; i ++)
	{
		pCopy--;
		*pCopy = *pBuffer;
		pBuffer++;

	}
	//// Reset the Buffer pointer
	pBuffer -= nByteLength;

	//// Set the value back
	memcpy(pValue, pCopy, nByteLength);

	delete[] pBuffer;
	delete[] pCopy;
}

void ReverseByteOrder(unsigned int& nValue)
{
	unsigned char* pBytes = (unsigned char*) &nValue;

	unsigned char nSpare = pBytes[0];

	pBytes[0] = pBytes[3];

	pBytes[3] = nSpare;

	nSpare = pBytes[1];

	pBytes[1] = pBytes[2];

	pBytes[2] = nSpare;
}



void ReverseByteOrder(int& nValue)
{
	unsigned char* pBytes = (unsigned char*) &nValue;

	unsigned char nSpare = pBytes[0];

	pBytes[0] = pBytes[3];

	pBytes[3] = nSpare;

	nSpare = pBytes[1];

	pBytes[1] = pBytes[2];

	pBytes[2] = nSpare;
}


void ReverseByteOrder(unsigned short& nValue)
{
	unsigned char* pBytes = (unsigned char*) &nValue;

	unsigned char nSpare = pBytes[0];

	pBytes[0] = pBytes[1];

	pBytes[1] = nSpare;
}


void ReverseBitOrder(void* pValue, int nByteLength)
{
	unsigned char* pBuffer = new unsigned char[nByteLength];
	unsigned char* pCopy = new unsigned char[nByteLength];
	// Copy the value of the arg into the buffer.
	memcpy(pBuffer, pValue, nByteLength);

	//// increment pCopy to its last byte
	pCopy += nByteLength;
	//// copy each byte from the buffer into the copy in reverse order
	for (int i = 0 ; i < nByteLength; i ++)
	{
		pCopy--;
		ReverseBitOrder(pBuffer);
		*pCopy = *pBuffer;
		pBuffer++;

	}
	//// Reset the Buffer pointer
	pBuffer -= nByteLength;

	//// Set the value back
	memcpy(pValue, pCopy, nByteLength);

	delete[] pBuffer;
	delete[] pCopy;



}

void ReverseBitOrder(unsigned char* pValue)
{
	unsigned char chTemp = *pValue;

	*pValue = 0;

	for (int i = 0 ; i < 8 ; i++)
	{
		SetBit(pValue, i, GetBit(&chTemp, 7 - i));
	}
}

bool GetBit(unsigned char* pValue, int nBit)
{
	return ( *pValue & (1 << nBit)  ) > 0;
}

// nBit = 0 (Liitle Endian) smallest value to 7 (Big Endian).
void SetBit(unsigned char* pValue, int nBit, bool bOne)
{

	unsigned char nTemp = 1 << nBit;
	if (bOne)
		*pValue = *pValue | nTemp;
	else
	{
		nTemp = ~nTemp;
		*pValue = *pValue & nTemp;
	}
}

}